package Top;

// ================================================================

(* synthesize *)
module mkTop (Empty);

    Reg#(Bit#(3)) control <- mkReg(0);
    PulseWire ready <- mkPulseWire();

   Reg #(Bit #(3)) rg_state_seq   <- mkReg (1);
   Reg #(Bit #(2)) rg_state_par_A <- mkReg (0);    // 0 means not started yet
   Reg #(Bit #(2)) rg_state_par_B <- mkReg (0);    // 0 means not started yet

   // ----------------
   // SEQ 1

   rule rl_seq_1 (rg_state_seq == 1);
      control <= 1;

      rg_state_seq   <= 2;
      rg_state_par_A <= 1;
      rg_state_par_B <= 1;
   endrule

   // ----------------
   // SEQ 2 (PAR block)

   rule rl_seq_2_par_A_1 (rg_state_par_A == 1);
      control <= 2;

      rg_state_par_A <= 2;
   endrule

   rule rl_seq_2_par_B_1 ((rg_state_par_B == 1) && ready);

      rg_state_par_B <= 2;
   endrule

   rule rl_seq_2_endpar ((rg_state_par_A == 2) && (rg_state_par_B == 2));
      rg_state_seq <= 3;
   endrule

   // ----------------
   // SEQ 3

   rule rl_seq_3 (rg_state_seq == 3);
      control <= 0;

      rg_state_seq <= 4;
   endrule

   rule rl_endseq (rg_state_seq == 4);
      $finish (0);
   endrule

endmodule

// ================================================================

endpackage
